<?php

/**
 * Models that store data in Mongo
 */
namespace App\Traits;

trait UseMongo
{
	/**
	 * Resolve a connection instance.
	 * We need to do this, because our relations are in pgsql and somehow loading a relation changes this models
	 * connection information. Using protected $connection is not enough.
	 *
	 * @param  string|null  $connection
	 */
	public static function resolveConnection($connection = null)
	{
		return static::$resolver->connection('mongodb');
	}

	/* ATTRIBUTES */

	public function getMsgAttribute($value): string
	{
		return utf8_decode($value);
	}

	public function setMsgAttribute($value): void
	{
		$this->attributes['msg'] = utf8_encode($value);
	}
}